/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/simulation/mrsim-genom3/work/templates/ros/client/ros/mrsim/msg/genom_state_stats.msg
 *
 */


#ifndef MRSIM_MESSAGE_GENOM_STATE_STATS_H
#define MRSIM_MESSAGE_GENOM_STATE_STATS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mrsim
{
template <class ContainerAllocator>
struct genom_state_stats_
{
  typedef genom_state_stats_<ContainerAllocator> Type;

  genom_state_stats_()
    : last(0.0)
    , max(0.0)
    , avg(0.0)  {
    }
  genom_state_stats_(const ContainerAllocator& _alloc)
    : last(0.0)
    , max(0.0)
    , avg(0.0)  {
    }



   typedef float _last_type;
  _last_type last;

   typedef float _max_type;
  _max_type max;

   typedef float _avg_type;
  _avg_type avg;




  typedef boost::shared_ptr< ::mrsim::genom_state_stats_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mrsim::genom_state_stats_<ContainerAllocator> const> ConstPtr;

}; // struct genom_state_stats_

typedef ::mrsim::genom_state_stats_<std::allocator<void> > genom_state_stats;

typedef boost::shared_ptr< ::mrsim::genom_state_stats > genom_state_statsPtr;
typedef boost::shared_ptr< ::mrsim::genom_state_stats const> genom_state_statsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mrsim::genom_state_stats_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mrsim::genom_state_stats_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mrsim

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'mrsim': ['mrsim/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mrsim::genom_state_stats_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mrsim::genom_state_stats_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim::genom_state_stats_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim::genom_state_stats_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim::genom_state_stats_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim::genom_state_stats_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mrsim::genom_state_stats_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ea24c2f8ade7231dc68f4d4e614da226";
  }

  static const char* value(const ::mrsim::genom_state_stats_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xea24c2f8ade7231dULL;
  static const uint64_t static_value2 = 0xc68f4d4e614da226ULL;
};

template<class ContainerAllocator>
struct DataType< ::mrsim::genom_state_stats_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mrsim/genom_state_stats";
  }

  static const char* value(const ::mrsim::genom_state_stats_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mrsim::genom_state_stats_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::genom::state::stats\n\
float32 last\n\
float32 max\n\
float32 avg\n\
";
  }

  static const char* value(const ::mrsim::genom_state_stats_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mrsim::genom_state_stats_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.last);
      stream.next(m.max);
      stream.next(m.avg);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct genom_state_stats_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mrsim::genom_state_stats_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mrsim::genom_state_stats_<ContainerAllocator>& v)
  {
    s << indent << "last: ";
    Printer<float>::stream(s, indent + "  ", v.last);
    s << indent << "max: ";
    Printer<float>::stream(s, indent + "  ", v.max);
    s << indent << "avg: ";
    Printer<float>::stream(s, indent + "  ", v.avg);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MRSIM_MESSAGE_GENOM_STATE_STATS_H
